/* gfunctions.h - structures and constants for gfunctions.c
 * "Alpha" state. Use at your own risk!
 * Copyright 2015 Mihai Gaitos, mihaig@hawk.ro
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that the
 * above copyright notice and the following two paragraphs appear in
 * all copies of this software.
 *
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN
 * IF THE COPYRIGHT HOLDER HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 *
 * THE COPYRIGHT HOLDER SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE COPYRIGHT HOLDER HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 */
#define PX_ADD 1	/* bit 0 of mode - plot,draw,rect mode to add colors */
#define PLOTMASK 3	/* bits 0 and 1 of mode are used by plot */
#define R_FILLED 4	/* bit 2 of mode - rect mode for filled rectangles */

/* plot errors */
#define X_OUT_OF_RANGE 1
#define Y_OUT_OF_RANGE 2
#define G_OK 0

typedef struct {
    uint8_t r;
    uint8_t g;
    uint8_t b;
} pixel_t;

typedef struct {
	uint32_t size;
	uint32_t width;
	uint32_t height;
	uint32_t wbytes;
	uint8_t data[];
} font_t;


